%global __brp_check_rpaths %{nil}
%global packname  kko
%global packver   1.0.1
%global rlibdir   /usr/local/lib/R/library

Name:             R-CRAN-%{packname}
Version:          1.0.1
Release:          1%{?dist}%{?buildtag}
Summary:          Kernel Knockoffs Selection for Nonparametric Additive Models

License:          GPL (>= 2)
URL:              https://cran.r-project.org/package=%{packname}
Source0:          %{url}&version=%{packver}#/%{packname}_%{packver}.tar.gz


BuildRequires:    R-devel >= 3.6.3
Requires:         R-core >= 3.6.3
BuildArch:        noarch
BuildRequires:    R-CRAN-grpreg 
BuildRequires:    R-CRAN-knockoff 
BuildRequires:    R-CRAN-doParallel 
BuildRequires:    R-parallel 
BuildRequires:    R-CRAN-foreach 
BuildRequires:    R-CRAN-ExtDist 
Requires:         R-CRAN-grpreg 
Requires:         R-CRAN-knockoff 
Requires:         R-CRAN-doParallel 
Requires:         R-parallel 
Requires:         R-CRAN-foreach 
Requires:         R-CRAN-ExtDist 

%description
A variable selection procedure, dubbed KKO, for nonparametric additive
model with finite-sample false discovery rate control guarantee. The
method integrates three key components: knockoffs, subsampling for
stability, and random feature mapping for nonparametric function
approximation. For more information, see the accompanying paper: Dai, X.,
Lyu, X., & Li, L. (2021). “Kernel Knockoffs Selection for Nonparametric
Additive Models”. arXiv preprint <arXiv:2105.11659>.

%prep
%setup -q -c -n %{packname}

# fix end of executable files
find -type f -executable -exec grep -Iq . {} \; -exec sed -i -e '$a\' {} \;
# prevent binary stripping
[ -d %{packname}/src ] && find %{packname}/src -type f -exec \
  sed -i 's@/usr/bin/strip@/usr/bin/true@g' {} \; || true
[ -d %{packname}/src ] && find %{packname}/src/Make* -type f -exec \
  sed -i 's@-g0@@g' {} \; || true
# don't allow local prefix in executable scripts
find -type f -executable -exec sed -Ei 's@#!( )*/usr/local/bin@#!/usr/bin@g' {} \;

%build

%install

mkdir -p %{buildroot}%{rlibdir}
%{_bindir}/R CMD INSTALL -l %{buildroot}%{rlibdir} %{packname}
test -d %{packname}/src && (cd %{packname}/src; rm -f *.o *.so)
rm -f %{buildroot}%{rlibdir}/R.css
# remove buildroot from installed files
find %{buildroot}%{rlibdir} -type f -exec sed -i "s@%{buildroot}@@g" {} \;

%files
%{rlibdir}/%{packname}
